<template>

<div class="
    flex
    flex-wrap
    items-center
">
    <b class="mr-4">
        {{ $t(name) }}
    </b>

    <input
        v-bind:value="value.toNumber()"
        v-on:input="update"
        v-bind:min="min"
        v-bind:max="max"
        v-bind:step="step"
        type="range"
        class="
        flex-1
        m-2
    ">

    <div class="
        flex
        items-center
        bg-white
        dark:bg-cgray-900
        rounded-lg
        w-full
    ">
        <input
            v-bind:value="value.toNumber()"
            v-on:input="update"
            class="
            flex-auto
            appearance-none
            border-2
            border-white
            bg-transparent
            dark:border-cgray-900
            rounded-lg
            rounded-r-none
            px-2
            lg:px-4
            py-2
            leading-tight
            focus:shadow-outline
            focus:border-blue-500
            dark:focus:border-blue-400
        "/>
        <p class="
            flex-0
            border-l-2
            border-grey-200
            px-2
            lg:px-4
        ">
            {{ value.toUnit() }}
        </p>
    </div>
</div>

</template>

<script lang='ts'>

import { Component, Prop, Vue } from 'vue-property-decorator';
import { State } from 'vuex-class';

import { Project } from '@/ts/project';
import { Unit } from '@/ts/unit';

@Component
export default class C extends Vue {
    @State('project')
    private project!: Project;

    @Prop()
    private value!: Unit;

    @Prop()
    private name!: string;

    @Prop()
    private min!: number;

    @Prop()
    private max!: number;

    @Prop()
    private step!: number;

    private update(event: any): void {
        this.value.setNumber(event.target.value);
        this.$emit('input');
        this.project.update();
    }
}

</script>
